--------------------------------------------------------------------------------
-- [VHDL Praktikum SS2004]
--
-- Aufgabe 3:     Minima-Rechenwerk
-- Entity:        E_MINIMA (Top-Level-Entity)               
--
-- Andreas Schibilla (ii4900)
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;


--------------------------------------------------------------------------------
-- Inkrementierer-Entity    
--------------------------------------------------------------------------------
entity E_PLUS_EINS is    
    port (         
         CLK: in std_logic;
        A_IMPULS: in  std_logic;
        S_IN:     in  std_logic;
        S_OUT:    out std_logic
    );
end E_PLUS_EINS;


--------------------------------------------------------------------------------
-- Inkrementierer-Architecture
-- inkrementiert das seriell anliegende 20-Bit-Wort
--------------------------------------------------------------------------------
architecture A_PLUS_EINS of E_PLUS_EINS is
signal INT_CARRY : std_logic; -- := '1';
begin      
 -- Ergebnis entpricht Eingang + Eins (Carry wird durchgereicht)
 S_OUT      <= S_IN xor INT_CARRY;
   
 P1: process(CLK, S_IN, INT_CARRY)
 begin
   if rising_edge(CLK) then
   
      if A_IMPULS = '1' then                    -- A-Impuls steuert Zuweisung
         INT_CARRY   <= S_IN and INT_CARRY;
      else                                      -- nach Ende des A-Impulses
         INT_CARRY   <= '1';                    -- Carry wieder initialisieren
      end if;
      
   end if;
 end process P1;    

end A_PLUS_EINS;




